#===============================================================================
#Prototype AJAX Test: Server side script (start first)
#USAGE: main.py <port>
#
#Denis Dube, July 2006
#===============================================================================
import sys
import SimpleHTTPServer
import SocketServer
import string



def startHTTPServer(port):
  """
  Minimal web server.
  Serves files relative to the current directory and only one file: fileNameToAllow
  Expects "POST" requests from the scripted fileNameToAllow
  """

  class Handler(SimpleHTTPServer.SimpleHTTPRequestHandler):
    path_tab = [0,0]
    window_tab = [0]
    tab_pts = []
    second = [0,0]
    tab_oldpt=[0]
    modeString = ["Draw","Idle"]
    moveMode = "Idle"
    def __init__(self, request, client_address, server):
	
	
	#self.modes = [ "Draw", "Move",  "Delete", "Continue"]

	self.contenu = ""
	
	SimpleHTTPServer.SimpleHTTPRequestHandler.__init__(self, request, client_address, server)

    def do_GET(self):
      """ Allow users to access the XML/Javascript front-end in Firefox """
      f = self.send_head()
      if f:
        self.copyfile(f, self.wfile)
        f.close()  
        
    def do_POST(self):
	

	self.path_tab = string.split(self.path,'?')
	
	if(self.path_tab[0]=="/insertButtonpressed"):
		print("Le mode actuel est l'insertion")
		self.modeString[0] = "Draw"
	elif (self.path_tab[0]=="/moveButtonpressed"):
		print ("Le mode actuel est le deplacement")
		self.modeString[0] = "Move"
	elif (self.path_tab[0]=="/deleteButtonpressed"):
		print("Le mode actuel est la suppression")
		self.modeString[0]  = "Delete"
	elif (self.path_tab[0]=="/mouse1press"):
		self.mouse1Press()
	elif (self.path_tab[0]=="/mouse1motion"):
		self.mouse1Motion()
	elif (self.path_tab[0] =="/mouse1released"):
		self.mouse1released()
	elif(self.path_tab[0]=="/mouse1press_select"):
		self.mouse1Press()
	elif(self.path_tab[0]=="/open_window"):
		print "New window"
		self.openNewWindow()
	
    def mouse1released(self):
	if self.modeString[0] == "Move": 
		if self.modeString[1] == "Moving":
			self.modeString[1] = "Idle"
			print ("released")

    def mouse1Motion(self):
	if self.modeString[0] == "Move": 
		if self.modeString[1] == "Moving":
			self.contenu+="var objet=svgdoc.getElementById('"+self.tab_oldpt[0]+"');"
			self.contenu+="var ox2 = objet.getAttribute(\"x2\");"
			self.contenu+="var oy2 = objet.getAttribute(\"y2\");"
			self.contenu+="var ox1 = objet.getAttribute(\"x1\");"
			self.contenu+="var oy1 = objet.getAttribute(\"y1\");"
			self.contenu+="objet.setAttribute(\"x1\" , "+self.path_tab[1]+");"
			self.contenu+="objet.setAttribute(\"y1\" , "+self.path_tab[2]+");"
			self.contenu+="objet.setAttribute(\"x2\" , ox2-(ox1-"+self.path_tab[1]+"));"
			self.contenu+="objet.setAttribute(\"y2\" , oy2-(oy1-"+self.path_tab[2]+"));"
			self.wfile.write(self.contenu)
		

    def mouse1Press(self):
	if self.modeString[0] == 'Draw':
		if self.second[0] == 0 :
			self.tab_pts.append(self.path_tab[1])
			self.tab_pts.append(self.path_tab[2])
			self.second[0] = 1
		else:
			self.contenu+="var objet=svgdoc.getElementById(\"line\");"
			self.contenu+="var newline=objet.cloneNode(false);"
			self.contenu+="newline.setAttributeNS(null , \"x1\" , "+self.tab_pts[0]+");"
			self.contenu+="newline.setAttributeNS(null , \"y1\" , "+self.tab_pts[1]+");"
			self.contenu+="newline.setAttributeNS(null , \"x2\" , "+self.path_tab[1]+");"
			self.contenu+="newline.setAttributeNS(null , \"y2\" , "+self.path_tab[2]+");"
			self.contenu+="newline.setAttributeNS(null , \"id\" , \"line"+str(self.second[1])+"\");"
			self.contenu+="var contents = svgdoc.getElementById(\"affiche\");"
			self.contenu+="contents.appendChild (newline);"
			self.second[1] += 1
			self.wfile.write(self.contenu)
			self.tab_pts.pop(0)
			self.tab_pts.pop(0)
			self.second[0] = 0
			
	elif self.modeString[0] == "Delete":
		if(len(self.path_tab)==4):
			self.contenu+="var contents=svgdoc.getElementById('affiche');"
			self.contenu+="var objet=svgdoc.getElementById('"+self.path_tab[3]+"');"
			self.contenu+="contents.removeChild(objet);"
			self.wfile.write(self.contenu)
			
		
	elif self.modeString[0] == "Move":
		if(len(self.path_tab)==4):
			self.modeString[1] = "Moving"
			self.tab_oldpt[0] = self.path_tab [3]
		
		
	else:
		print "Unknown mode"
		
	
    def openNewWindow(self):
	self.contenu += "WindowObjectReference = window.open(\"./drawingtool1.xml\",\"windowName"+str(self.window_tab[0])+"\",\"resizable=no,scrollbars=yes,status=no\");"
	self.wfile.write(self.contenu)
	self.window_tab[0] += 1
      
      
  httpd = SocketServer.TCPServer(("", port), Handler)
  
  print "HTTP server is now serving at port", port
  httpd.serve_forever()
     
    
if __name__ == '__main__':
  if(len(sys.argv) == 2):
    port = int(sys.argv[1])
  else:
    port = 8080
  startHTTPServer(port)
  
  

