from Tkinter import *

class Droite(Frame):
	def __init__(self,
               master=None,height=500, width=500):
		

		Frame.__init__(self, master)
		self.pack(fill=BOTH, expand=1)
		self.drawing=Canvas(self, bg = "white",width = 500, height = 500)
		self.line = self.drawing.create_line((0,400,500,400), fill = "grey", width = 4)
		self.rectangle = self.drawing.create_rectangle(0,400,500,500,fill = "grey")
		self.label = self.drawing.create_text(70,440,fill = "blue", text = "")
		self.insert_valid = self.drawing.create_text(70,440,fill = "blue", text = "@")
		self.drawing.create_text(95,440,fill = "black", text = "Insert")
		self.move_valid = self.drawing.create_text(230,440,fill = "black", text = "o")
		self.drawing.create_text(257,440,fill = "black", text = "Move")
		self.delete_valid = self.drawing.create_text(390,440,fill = "black", text = "o")
		self.drawing.create_text(420,440,fill = "black", text = "Delete")
		self.drawing.focus_set()
		self.drawing.pack()

		self.tab_pts = []
		self.second = 0

		#self.modes = [ "Draw", "Move",  "Delete", "Continue"]
		self.modeString = "Draw"
		self.moveMode = "Idle"
		self.rect2 = self.drawing.create_rectangle(220,470,270,492,fill = "white")
		self.label = self.drawing.create_text(245,480,fill = "red", text = self.modeString)

		#self.modeSelect = Frame(self)

		#self.modeDisplay = Label(textvar = self.modeSelected, relief=GROOVE, width=20, fg="red")
		#self.modeDisplay.pack(side=BOTTOM, padx = 2, pady = 6)

		#for text in self.modes:
		#	self.b = Radiobutton(self, text=text, variable=self.modeSelected, 
		#		value=text, width = 10, wraplength = 60)
		#	self.b.pack(side=LEFT, padx = 2, pady = 2)

		self.drawing.bind("<ButtonPress-1>", self.onDrawingMouse1Press)
		self.drawing.bind("<ButtonRelease-1>", self.onDrawingMouse1Release)
		self.drawing.bind("<B1-Motion>", self.onDrawingMouse1Motion)

	def delete(self,event):
		self.drawing.delete(self.drawing.find_closest(event.x, event.y))

	def defineMode(self,event,mode):
		if (event.y > 420 and event.y < 470):
			if (event.x > 65 and event.x < 130 ):
				print "Changement pour insert"
				self.drawing.itemconfigure(self.insert_valid , fill="blue" , text = "@")
				self.drawing.itemconfigure(self.move_valid , fill="black" , text = "o")
				self.drawing.itemconfigure(self.delete_valid , fill="black" , text = "o")
				return "Draw"
			elif (event.x > 225 and event.x < 290 ):
				print "Changement pour Move"
				self.drawing.itemconfigure(self.insert_valid , fill="black" , text = "o")
				self.drawing.itemconfigure(self.move_valid , fill="blue" , text = "@")
				self.drawing.itemconfigure(self.delete_valid , fill="black" , text = "o")
				return "Move"
			elif (event.x > 385 and event.x < 450 ):
				print "Changement pour Delete"
				self.drawing.itemconfigure(self.insert_valid ,fill="black" , text = "o")
				self.drawing.itemconfigure(self.move_valid , fill="black" , text = "o")
				self.drawing.itemconfigure(self.delete_valid , fill="blue" , text = "@")
				return "Delete"
			else:
				print " X pas bon"
				return mode
		else:
			print "Y pas bon"
			return mode
			


	def onDrawingMouse1Release(self, event):
		if self.modeString == "Move": 
			if self.moveMode == "Moving":
				self.moveMode = "Idle"

	def onDrawingMouse1Motion(self, event):
		if self.modeString == "Move": 
			if self.moveMode == "Moving":
				if event.y < 400:
					self.oldCoords=self.drawing.coords(self.movingObject)
					self.drawing.move(self.movingObject, event.x-self.oldCoords[0],
						event.y-self.oldCoords[1])
  
	def onDrawingMouse1Press(self, event):
		if (event.y>400):
			if self.modeString == "Move":
				if self.moveMode == "Moving":
					self.moveMode = "Idle"
			print "Passe par la"
			self.modeString = self.defineMode(event,self.modeString)
			self.drawing.itemconfigure(self.label, text = self.modeString)
		elif self.modeString == "Draw":
			if self.second == 2:
				self.tab_pts.pop(0)
				self.tab_pts.pop(0)
				self.second = 0
			if self.second == 0:
				self.tab_pts.append(event.x)
				self.tab_pts.append(event.y)
				self.second = 1
			else:
				self.tab_pts.append(event.x)
				self.tab_pts.append(event.y)
				self.drawing.create_line((self.tab_pts[0], self.tab_pts[1], self.tab_pts[2], 
					self.tab_pts[3]), fill="red",width = 2)
				self.tab_pts.pop(0)
				self.tab_pts.pop(0)
				self.tab_pts.pop(0)
				self.tab_pts.pop(0)
				self.second = 0
		elif self.modeString == "Continue":
			if self.second == 0:
				self.tab_pts.append(event.x)
				self.tab_pts.append(event.y)
				self.second = 2
			else:
				self.tab_pts.append(event.x)
				self.tab_pts.append(event.y)
				self.drawing.create_line((self.tab_pts[0], self.tab_pts[1], self.tab_pts[2], 
					self.tab_pts[3]), fill="red",width = 2)
				self.tab_pts.pop(0)
				self.tab_pts.pop(0)
				self.second = 2
		elif self.modeString == "Delete":
			self.objet_selected = self.drawing.find_closest(event.x, event.y)
			print self.objet_selected[0]
			print self.line
			if (self.objet_selected[0] == self.line or self.movingObject[0] == self.rectangle):
				print "Cet objet est impossible a supprimer"
			else:
				self.drawing.delete(self.objet_selected)
		elif self.modeString == "Move":
			self.moveMode = "Moving" 
			self.movingObject = self.drawing.find_closest(event.x, event.y)
			if (self.movingObject[0] == self.line or self.movingObject[0] == self.rectangle):
				print "Cet objet est impossible a deplacer"
				self.moveMode = "idle"
				self.movingObject = None
		else:
			print "Unknown mode"



root = Tk()
droite = Droite(root)

root.mainloop()

