/* Tinker with viewbox: http://www.kevlindev.com/gui/utilities/viewbox/index.htm
 * 
 * 
 */

//----------------------------------------------------------------------
// static data

var SVG_NS ="http://www.w3.org/2000/svg";

//----------------------------------------------------------------------
// Helper functions

function suspendRedraw()
{
  // asv doesn't implement suspendRedraw, so we wrap this in a try-block:
  try {
    document.documentElement.suspendRedraw(0);
  }
  catch(e) {}
}

function unsuspendRedraw()
{
  // asv doesn't implement unsuspendRedraw, so we wrap this in a try-block:
  try {
    document.documentElement.unsuspendRedraw(0);
  }
  catch(e) {}
}


function getSVGElementByID(svgNode, ID){
	// Returns the SVG element by ID inside of a SVG group (but does not recurse group)
	for(var index=0; index < svgNode.childNodes.length; index++) {
		if(svgNode.childNodes[index].id == ID){
			return svgNode.childNodes[index];
		}
	}
	return null;
}


// Safe evaluation of javascript that parses Strings
String.prototype.parseJSON = function () {
    try {
        return !(/[^,:{}\[\]0-9.\-+Eaeflnr-u \n\r\t]/.test(
                this.replace(/"(\\.|[^"\\])*"/g, ''))) &&
            eval('(' + this + ')');
    } catch (e) {
        return false;
    }
};


function AJAX(requestString){
	var req = new XMLHttpRequest(); // Works on Firefox, good enough for now...
  req.open("POST", requestString, true); // ASYNC Request
  return req;    
}


//----------------------------------------------------------------------
// Text class



//----------------------------------------------------------------------
// Rectangle class






